调用方法1
# 生成 lens_params 参数
lens_params = {
    'ml': 1e9,              # 镜质量 (太阳质量)
    'beta': 2.5e-5,         # 入射角 (弧度)
    'zs': 2.0,              # 背景源红移
    'zl': 1.0,              # 镜红移
    'lens_model': 'point-mass'  # 透镜模型
}

# 生成 waveform_params 参数
waveform_params = {
    'approximant': 'IMRPhenomD',  # 波形近似模型
    'mass1': 50000,                  # 第一个天体的质量 (太阳质量)
    'mass2': 40000,                  # 第二个天体的质量 (太阳质量)
    'distance': lumDis(lens_params['zs']),  # 距离 (Mpc)，使用 lens_params 的 zs
    'inclination': 0              # 入射角 (弧度)
}


# 计算放大后的波形
result = compute_lensed_waveform(waveform_params, lens_params)

# 绘制结果
frequencies = result["frequencies"]
original_waveformhp = result["original_waveformhp"]
lensed_waveformhp = result["lensed_waveformhp"]
amplification = result["amplification"]


plt.figure(figsize=(10, 6))
plt.plot(frequencies, amplification.real, label="Original |hp(f)|", alpha=0.7)
plt.xlabel("Frequency (Hz)")
plt.ylabel("Amplitude")
plt.title("Lensed vs Original Frequency Domain Waveform")
plt.legend()
plt.show()



plt.figure(figsize=(10, 6))
plt.plot(frequencies, original_waveformhp.real, label="Original |hp(f)|", alpha=0.7)
plt.xlabel("Frequency (Hz)")
plt.ylabel("Amplitude")
plt.title("Lensed vs Original Frequency Domain Waveform")
plt.legend()
plt.show()

plt.figure(figsize=(10, 6))
plt.plot(frequencies, original_waveformhp.real, label="Original hp(f)", alpha=0.7)
plt.plot(frequencies, lensed_waveformhp.real, label="Lensed hp(f)", alpha=0.7)
plt.xlabel("Frequency (Hz)")
plt.ylabel("Amplitude")
plt.title("Lensed vs Original Frequency Domain Waveform")
plt.legend()
plt.show()

调用方法2
# 生成 lens_params 参数
lens_params = {
    'ml': 1e6,              # 镜质量 (太阳质量)
    'beta': 2.5e-5,         # 入射角 (弧度)
    'zs': 2.0,              # 背景源红移
    'zl': 1.0,              # 镜红移
    'lens_model': 'point-mass'  # 透镜模型
}

# 生成 waveform_params 参数
waveform_params = {
    'approximant': 'IMRPhenomD',  # 波形近似模型
    'mass1': 30,                  # 第一个天体的质量 (太阳质量)
    'mass2': 20,                  # 第二个天体的质量 (太阳质量)
    'distance': lumDis(lens_params['zs']),  # 距离 (Mpc)，使用 lens_params 的 zs
    'inclination': 0              # 入射角 (弧度)
}

# 计算放大后的波形，频率区间大，运算耗时久
result = compute_lensed_waveform(waveform_params, lens_params)

# 绘制结果
frequencies = result["frequencies"]
original_waveformhp = result["original_waveformhp"]
lensed_waveformhp = result["lensed_waveformhp"]

plt.figure(figsize=(10, 6))
plt.plot(frequencies, original_waveformhp.real, label="Original hp(f)", alpha=0.7)
plt.plot(frequencies, lensed_waveformhp.real, label="Lensed hp(f)", alpha=0.7)
plt.xlabel("Frequency (Hz)")
plt.ylabel("Amplitude")
plt.title("Lensed vs Original Frequency Domain Waveform")
plt.legend()
plt.show()


zrj
2024-12-12